﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.OleDb;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class Samples_WebDataGrid_Sample : System.Web.UI.Page
{

    #region "Page Events" 

    /// <summary>
    /// 
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void Page_Load(object sender, EventArgs e)
    {

        if (!this.IsPostBack)
        {
            this.LoadColumns();
        }

        this.wbAARS.ClearDataSource();
        this.wbAARS.DataSource = this.GetProducts();
        this.wbAARS.DataBind();

    }

    #endregion

    #region "Functions"

    /// <summary>
    /// 
    /// </summary>
    /// <param name="id"></param>
    /// <param name="datasource"></param>
    /// <param name="textField"></param>
    /// <param name="valueField"></param>
    /// <returns></returns>
    private static Infragistics.Web.UI.GridControls.DropDownProvider CreateDropDownProvider(string id, DataSet datasource, string textField, string valueField)
    {

        Infragistics.Web.UI.GridControls.DropDownProvider provider = new Infragistics.Web.UI.GridControls.DropDownProvider();

        provider.ID = id;
        provider.EditorControl.DisplayMode = Infragistics.Web.UI.ListControls.DropDownDisplayMode.DropDownList;
        provider.EditorControl.TextField = textField;
        provider.EditorControl.ValueField = valueField;
        provider.EditorControl.DataSource = datasource;

        return provider;

    }

    /// <summary>
    /// 
    /// </summary>
    /// <param name="columnKey"></param>
    /// <param name="editorId"></param>
    /// <param name="isReadOnly"></param>
    /// <returns></returns>
    /// <remarks></remarks>
    private static Infragistics.Web.UI.GridControls.ColumnEditSetting CreateEditingColumnSetting(string columnKey, string editorId, bool isReadOnly)
    {

        Infragistics.Web.UI.GridControls.ColumnEditSetting setting = new Infragistics.Web.UI.GridControls.ColumnEditSetting();

        setting.ColumnKey = columnKey;
        setting.EditorID = editorId;
        setting.ReadOnly = isReadOnly;

        return setting;

    }

    /// <summary>
    /// 
    /// </summary>
    /// <param name="columnName"></param>
    /// <returns></returns>
    private Infragistics.Web.UI.GridControls.BoundDataField CreateGridColumn(String columnName)
    {
        Infragistics.Web.UI.GridControls.BoundDataField gridCol = new Infragistics.Web.UI.GridControls.BoundDataField();

        if (columnName.Equals("Discontinued"))
        {
            // check for this boolean column
            gridCol = new Infragistics.Web.UI.GridControls.BoundCheckBoxField();
        }
        else if (columnName.Equals("UnitPrice") || columnName.Equals("QuantityPerUnit"))
        {
            // right justify numbers
            gridCol.CssClass = "Right";
        }

        gridCol.Key = columnName;
        gridCol.DataFieldName = columnName;
        gridCol.Header.Text = columnName;

        return gridCol;
    }

    /// <summary>
    /// 
    /// </summary>
    /// <param name="key"></param>
    /// <param name="value"></param>
    /// <param name="text"></param>
    /// <param name="jsCall"></param>
    /// <returns></returns>
    private Infragistics.Web.UI.NavigationControls.DataMenuItem CreateRowContextMenuItem(string key, string value, string text, string jsCall)
    {

        Infragistics.Web.UI.NavigationControls.DataMenuItem item = new Infragistics.Web.UI.NavigationControls.DataMenuItem();

        item.Text = text;
        item.Value = value;
        item.Key = key;
        item.Attributes.Add("OnClick", string.Format("javascript:{0};", jsCall));

        return item;

    }

    /// <summary>
    /// 
    /// </summary>
    private void LoadColumns()
    {

        this.wbAARS.Columns.Clear();

        // add some columns
        this.wbAARS.Columns.Add(CreateGridColumn("ProductID"));                 // read only and will set databinding event
        this.wbAARS.Columns.Add(CreateGridColumn("ProductName"));               // text box edit, will add some special handling on aspx and js
        this.wbAARS.Columns.Add(CreateGridColumn("CategoryID"));                  // drop down
        this.wbAARS.Columns.Add(CreateGridColumn("QuantityPerUnit"));           // numeric but will set read only for certain rows in JS
        this.wbAARS.Columns.Add(CreateGridColumn("UnitPrice"));                 // numeric
        this.wbAARS.Columns.Add(CreateGridColumn("Discontinued"));              // boolean, will try to hide certain cells in rowdatabound event

    }

    /// <summary>
    /// 
    /// </summary>
    private void LoadDropDownLists()
    {
        this.wbAARS.EditorProviders.Clear();
        this.wbAARS.Behaviors.EditingCore.Behaviors.CellEditing.ColumnSettings.Clear();

        this.wbAARS.EditorProviders.Add(
            CreateDropDownProvider(
                "CategoryProvider",
                this.GetCategories(),
                "CategoryName",
                "CategoryID"));

        this.wbAARS.Behaviors.EditingCore.Behaviors.CellEditing.ColumnSettings.Add(
            CreateEditingColumnSetting(
                "CategoryID",
                "CategoryProvider",
                false));

    }

    /// <summary>
    /// 
    /// </summary>
    private void LoadReadOnlyColumns()
    {

        this.wbAARS.Behaviors.EditingCore.Behaviors.CellEditing.ColumnSettings.Add(CreateEditingColumnSetting(
                                                                            "CSBALine",
                                                                            String.Empty,
                                                                            true));
    }

    #endregion

    #region "Webgrid Events"

    /// <summary>
    /// 
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void wbAARS_InitializeRow(object sender, Infragistics.Web.UI.GridControls.RowEventArgs e)
    {

        // get data record
        DataRowView data = (DataRowView)e.Row.DataItem;
        
        // do some special formatting for ProductName
        // if I put leading spaces on a record I need it to be saved and show up in the grid
        if (data["ProductName"] != DBNull.Value)
        {
            e.Row.Items[this.wbAARS.Columns["ProductName"].Index].Text = e.Row.Items[this.wbAARS.Columns["ProductName"].Index].Text.Replace(" ", "&nbsp;");
        }

        // do some special formatting for discontinued column.I want to be able to hide the checkbox for certain rows
        // check if category == beverages
        if (Convert.ToInt32(data["CategoryID"]) == 1)
        {
            // I just want to hide the checkbox in the cell? css is on aspx.
            e.Row.Items[this.wbAARS.Columns["Discontinued"].Index].CssClass = "HiddenCheckbox";
        }

    }

    /// <summary>
    /// 
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void wbAARS_RowSelectionChanged(object sender, Infragistics.Web.UI.GridControls.SelectedRowEventArgs e)
    {

        this.wdmRowContextMenu.Items.Clear();

        // do the copy row function
        this.wdmRowContextMenu.Items.Add(this.CreateRowContextMenuItem("Copy", "Copy", "Copy", "openCopyCSBA();"));

        // do the delete menu item
        this.wdmRowContextMenu.Items.Add(this.CreateRowContextMenuItem("Delete", "Delete", "Delete", "doDeleteRows();"));

        // only comes up if one row is selected

        if (e.CurrentSelectedRows.Count == 1)
        {
            DataRowView item = (DataRowView)e.CurrentSelectedRows[0].DataItem;

            // get csba value
            int accountLineId = int.Parse(e.CurrentSelectedRows[0].DataKey[0].ToString());
            string csbaLine = item["CSBALine"].ToString();

            // do the edit menu item
            this.wdmRowContextMenu.Items.Add(this.CreateRowContextMenuItem("Edit", "Edit", "Edit", "openEditLine(true);"));

            //// do document menu items
            //// check if there is a document first
            //DataTable dt = CSBAManager.GetCSBADocumentByAccountLineId(this.hfFiscalYear.Value, accountLineId);

            //if (dt.Rows.Count > 0)
            //{
            //    // if there is a document, offer two links, one to delete the attachment and one to replace
            //    this.wdmRowContextMenu.Items.Add(this.CreateRowContextMenuItem("ReplaceAttachment", "ReplaceAttachment", "Replace Attachment", string.Format("openFileUpload({0});", csbaLine)));

            //    // offer a delete attachment option. also set the account line id hidden field to be picked up after post back
            //    this.wdmRowContextMenu.Items.Add(this.CreateRowContextMenuItem("DeleteAttachment", "DeleteAttachment", "Delete Attachment", string.Format("var doDelete = confirm ('Are you sure you want to delete this attachment?'); " + "if (doDelete) {{ $('#<%= hfAccountLineId.ClientID %>').val({0}); " + "$('#<%= hfMessage.ClientID %>').val('Attachment Deleted'); " + "refreshPage('DELETE_ATTACHMENT'); }}", csbaLine)));


            //}
            //else
            //{
            //    // offer an attach option
            //    this.wdmRowContextMenu.Items.Add(this.CreateRowContextMenuItem("Add Attachment", "Add Attachment", "Add Attachment", string.Format("openFileUpload({0});", csbaLine)));

            //}

            // add a link menu item as long as we are not on summary bill

            //if (!this.hfSubcommitteeId.Value.Equals("0"))
            //{
            //    this.wdmRowContextMenu.Items.Add(this.CreateRowContextMenuItem("Link", "Link", "Link", string.Format("openLinkPopup({0});", csbaLine)));
            //}

            //// is this line already linked? if it is, offer a drill to detail option
            //string associatedLineId = item["associated_line_id"].ToString();

            //if (associatedLineId.Length > 0)
            //{
            //    string drillToSubcommitteeId = associatedLineId.Split(Convert.ToChar(":"))[0];

            //    this.wdmRowContextMenu.Items.Add(this.CreateRowContextMenuItem("DrillToDetail", "DrillToDetail", "Drill to Detail", string.Format("drillToDetail({0});", drillToSubcommitteeId)));

            //}

        }

    }

    #endregion

    #region "Data Binding Functions & Connection Strings"

    /// <summary>
    /// Connection String
    /// </summary>
    //private string _connectionString = "C:\\Users\\Public\\Documents\\Infragistics\\NetAdvantage 2012.2\\ASP.NET\\Samples\\Infragistics.Web.AspNET\\App_Data\\storage\\en-us\\mdb\\Nwind.mdb";
    //private String _connectionString = "~/App_Data/storage/en-us/mdb/Nwind.mdb";
    private string _connectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\\Users\\Public\\Documents\\Infragistics\\NetAdvantage 2012.2\\ASP.NET\\Samples\\Infragistics.Web.AspNET\\app_data\\storage\\en-US\\mdb\\Nwind.mdb;Persist Security Info=True";

    /// <summary>
    /// 
    /// </summary>
    /// <returns></returns>
    public DataSet GetCategories()
    {
        OleDbConnection connection = new OleDbConnection(_connectionString);
        connection.Open();

        DataSet ds = new DataSet();

        try
        {
            string sql = "SELECT * FROM [Categories]";

            OleDbDataAdapter da = new OleDbDataAdapter(sql, connection);
            da.Fill(ds);

            //TotalData(ref da, ref ds, ref connection);
        }
        catch (Exception e)
        {
            throw e;
        }
        finally
        {
            connection.Close();
        }

        return ds;
    }

    /// <summary>
    /// 
    /// </summary>
    /// <returns></returns>
    public DataSet GetProducts()
    {
        OleDbConnection connection = new OleDbConnection(_connectionString);
        connection.Open();

        DataSet ds = new DataSet();

        try
        {
            string sql = "SELECT * FROM [Products]";

            OleDbDataAdapter da = new OleDbDataAdapter(sql, connection);
            da.Fill(ds);

            //TotalData(ref da, ref ds, ref connection);
        }
        catch (Exception e)
        {
            throw e;
        }
        finally
        {
            connection.Close();
        }

        return ds;
    }

    /// <summary>
    /// 
    /// </summary>
    /// <param name="productId"></param>
    /// <param name="unitPrice"></param>
    /// <returns></returns>
    public Boolean UpdateProduct(int productId, double unitPrice)
    {

        OleDbConnection connection = new OleDbConnection(_connectionString);
        connection.Open();

        OleDbDataAdapter da = new OleDbDataAdapter();

        try
        {
            OleDbCommand accessUpdateCommand = new OleDbCommand("UPDATE [Products] SET [UnitPrice] = ? WHERE [ProductID] = ?", connection);
            accessUpdateCommand.Parameters.AddWithValue("UnitPrice", unitPrice);
            accessUpdateCommand.Parameters.AddWithValue("ProductId", productId);
            da.UpdateCommand = accessUpdateCommand;
            da.UpdateCommand.ExecuteNonQuery();
        }
        catch (Exception e)
        {
            throw e;
        }
        finally
        {
            connection.Close();
        }

        return true;
    }

    #endregion

    #region "Button Events"

    /// <summary>
    /// 
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void Button1_Click(object sender, EventArgs e)
    {
        // do nothing
    }

    #endregion


}